// --------------------------------------------------------------------------
//
// MouseExplorer                                      Ulrich Müller  05.10.10
//                                                    Aspire Processing 1.2.1
// Steuerung des Robo Explorers mit der Maus
//           FishFaceTX.DLL und Robo TX Controller (Motoren an M1 und M2)
//
// --------------------------------------------------------------------------

import ftcomputing.roboTX.*;
FishFaceTX tx = new FishFaceTX();
private int mitte, mitteOben, mitteUnten, mitteLinks, mitteRechts;
color farbe = color(255, 0, 0);

int speed(int pos) {
  if(pos > mitteRechts) pos = pos - mitteRechts; else pos = mitteLinks - pos;
  return (int)map(pos, 0, mitteLinks, 200, 512);
}
void setup() {
  size(300, 300);
  tx.openController("COM39");
  println("TX Controller gestartet");
  frameRate(12);
  mitte = height / 5;
  mitteOben = (height - mitte) / 2;
  mitteUnten = (height + mitte) / 2;
  mitteLinks = (width - mitte) / 2;
  mitteRechts = (width + mitte) / 2;
  mouseY = mitteOben + 1;
  mouseX = mitteLinks + 1;
}

void draw() {
  background(255);
  fill(farbe);
  if(tx.finish()) return;
  if(mouseY < mitteOben & mouseX < mitteLinks) {
    tx.speedMotor(Mot.M1, Dir.Left, speed(mouseX));
    tx.speedMotor(Mot.M2, Dir.Left, speed(mouseY));
    rect(0, 0, mitteLinks, mitteOben);
  }
  else if(mouseY < mitteOben & mouseX < mitteRechts) {
    tx.speedMotor(Mot.M1, Dir.Left, speed(mouseY));
    tx.speedMotor(Mot.M2, Dir.Left, speed(mouseY));
    rect(mitteLinks, 0, mitte, mitteOben);    
  }
  else if(mouseY < mitteOben) {
    tx.speedMotor(Mot.M1, Dir.Left, speed(mouseY));
    tx.speedMotor(Mot.M2, Dir.Left, speed(mouseX));
    rect(mitteRechts, 0, mitteLinks, mitteOben);    
  }
  else if(mouseY < mitteUnten & mouseX < mitteLinks) {
    tx.speedMotor(Mot.M1, Dir.Left, speed(mouseX));
    tx.speedMotor(Mot.M2, Dir.Right, speed(mouseX));
    rect(0, mitteLinks, mitteLinks, mitte);    
  }
  else if(mouseY < mitteUnten & mouseX < mitteRechts) {
    tx.setMotor(Mot.M1, Dir.Off);
    tx.setMotor(Mot.M2, Dir.Off);
  }
  else if(mouseY < mitteUnten) {
    tx.speedMotor(Mot.M1, Dir.Right, speed(mouseX));
    tx.speedMotor(Mot.M2, Dir.Left, speed(mouseX));
    rect(mitteRechts, mitteOben, mitteLinks, mitte);    
  }
  else if(mouseX < mitteLinks) {
    tx.speedMotor(Mot.M1, Dir.Right, speed(mouseX));
    tx.speedMotor(Mot.M2, Dir.Right, speed(mouseY));
    rect(0, mitteUnten, mitteLinks, mitteOben);    
  }
  else if(mouseX < mitteRechts) {
    tx.speedMotor(Mot.M1, Dir.Right, speed(mouseY));
    tx.speedMotor(Mot.M2, Dir.Right, speed(mouseY));
    rect(mitteLinks, mitteUnten, mitte, mitteOben);    
  }
  else {
    tx.speedMotor(Mot.M1, Dir.Right, speed(mouseY));
    tx.speedMotor(Mot.M2, Dir.Right, speed(mouseX));
    rect(mitteRechts, mitteUnten, mitteLinks, mitteOben);    
  }
}


