// --------------------------------------------------------------------------
//
// MouseExplorer2                                     Ulrich Müller  06.10.10
//                                                    Aspire Processing 1.2.1
// Steuerung des Robo Explorers mit der Maus
//           FishFaceTX.DLL und Robo TX Controller (Motoren an M1 und M2)
//           Die Mausbewegungen werden angezeigt, clear : LinksClick
//
// --------------------------------------------------------------------------

import ftcomputing.roboTX.*;
FishFaceTX tx = new FishFaceTX();
int mitte, mitteOben, mitteUnten, mitteLinks, mitteRechts;
color rot = color(255, 0, 0);
color gruen = color(0, 255, 0);
color weiss = color(255, 255, 255);

int speed(int pos) {
  if(pos > mitteRechts) pos = pos - mitteRechts; else pos = mitteLinks - pos;
  return (int)map(pos, 0, mitteLinks, 200, 512);
}
void newBoard() {
  background(rot);
  line(mitteLinks, 0, mitteLinks, height);
  line(mitteRechts, 0, mitteRechts, height);
  line(0, mitteOben, width, mitteOben);
  line(0, mitteUnten, width, mitteUnten);
  fill(weiss);
  rect(mitteLinks, mitteOben, mitte, mitte);
  fill(gruen);
}
void setup() {  
  size(300, 300);
  tx.openController("COM39");
  println("TX Controller gestartet");
  frameRate(12);
  mitte = height / 5;
  mitteOben = (height - mitte) / 2;
  mitteUnten = (height + mitte) / 2;
  mitteLinks = (width - mitte) / 2;
  mitteRechts = (width + mitte) / 2;
  mouseY = mitteOben + mitte / 2;
  mouseX = mitteLinks + mitte / 2;
  newBoard();
}

void draw() {
  if(tx.finish()) return;
  if(mousePressed) newBoard();
  ellipse(mouseX, mouseY, 16, 16);
  if(mouseY < mitteOben & mouseX < mitteLinks) {
    tx.speedMotor(Mot.M1, Dir.Left, speed(mouseX));
    tx.speedMotor(Mot.M2, Dir.Left, speed(mouseY));
  }
  else if(mouseY < mitteOben & mouseX < mitteRechts) {
    tx.speedMotor(Mot.M1, Dir.Left, speed(mouseY));
    tx.speedMotor(Mot.M2, Dir.Left, speed(mouseY));
  }
  else if(mouseY < mitteOben) {
    tx.speedMotor(Mot.M1, Dir.Left, speed(mouseY));
    tx.speedMotor(Mot.M2, Dir.Left, speed(mouseX));
  }
  else if(mouseY < mitteUnten & mouseX < mitteLinks) {
    tx.speedMotor(Mot.M1, Dir.Left, speed(mouseX));
    tx.speedMotor(Mot.M2, Dir.Right, speed(mouseX));
  }
  else if(mouseY < mitteUnten & mouseX < mitteRechts) {
    tx.setMotor(Mot.M1, Dir.Off);
    tx.setMotor(Mot.M2, Dir.Off);
  }
  else if(mouseY < mitteUnten) {
    tx.speedMotor(Mot.M1, Dir.Right, speed(mouseX));
    tx.speedMotor(Mot.M2, Dir.Left, speed(mouseX));
  }
  else if(mouseX < mitteLinks) {
    tx.speedMotor(Mot.M1, Dir.Right, speed(mouseX));
    tx.speedMotor(Mot.M2, Dir.Right, speed(mouseY));
  }
  else if(mouseX < mitteRechts) {
    tx.speedMotor(Mot.M1, Dir.Right, speed(mouseY));
    tx.speedMotor(Mot.M2, Dir.Right, speed(mouseY));
  }
  else {
    tx.speedMotor(Mot.M1, Dir.Right, speed(mouseY));
    tx.speedMotor(Mot.M2, Dir.Right, speed(mouseX));
  }
}


